	.module i2c.c
	.area lit
_abInit::
	.byte 't,0
	.byte 37,6
	.byte 36,15
	.byte 132
	.dbfile C:\projekte\msp430\ct05\i2c.c
	.dbsym e abInit _abInit A[7:7]c
_abCls::
	.byte 't,0
	.byte 132
	.dbsym e abCls _abCls A[3:3]c
_abText1::
	.byte 't,64
	.byte 227,167
	.byte 244,173
	.byte 210,239
	.byte 226
	.dbsym e abText1 _abText1 A[9:9]c
_abZeile2::
	.byte 't,0
	.byte 196
	.dbsym e abZeile2 _abZeile2 A[3:3]c
_abNr0::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 176
	.dbsym e abNr0 _abNr0 A[9:9]c
_abNr1::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 177
	.dbsym e abNr1 _abNr1 A[9:9]c
_abNr2::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 178
	.dbsym e abNr2 _abNr2 A[9:9]c
_abNr3::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 179
	.dbsym e abNr3 _abNr3 A[9:9]c
_abNr4::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 180
	.dbsym e abNr4 _abNr4 A[9:9]c
_abNr5::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 181
	.dbsym e abNr5 _abNr5 A[9:9]c
_abNr6::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 182
	.dbsym e abNr6 _abNr6 A[9:9]c
_abNr7::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 183
	.dbsym e abNr7 _abNr7 A[9:9]c
_abNr8::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 184
	.dbsym e abNr8 _abNr8 A[9:9]c
_abNr9::
	.byte 't,64
	.byte 211,244
	.byte 225,244
	.byte 229,160
	.byte 185
	.dbsym e abNr9 _abNr9 A[9:9]c
	.area text
	.dbfile C:\projekte\msp430\ct05\i2c.c
	.dbfunc e vStarti2c _vStarti2c fV
	.even
_vStarti2c::
	.dbline -1
	.dbline 83
; /***************************************************************************
; * Titel           : I2C.C
; *
; * Beschreibung    : IIC - Interface
; *
; * Kategorie       :
; *
; * Verantwortlich  : Jens Altenburg
; *
; * Modulhistory    :
; *
;  ----------------------------------------------------------------------------
;  Date     | Author          | Change
;  ----------------------------------------------------------------------------
;  28.09.03 | J. Altenburg    | Ersterstellung
;  ----------------------------------------------------------------------------
; 
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)
; ****************************************************************************/
; /* Own headerfiles */
; #include "i2c.h"                    /*  */
; 
; 
; 
; /***************************************************************************
; * FILE LOCAL DEFINITIONS
; *
; * In this section define
; * - all file local macros
; * - all file local define-constants
; * - all file local ROM-constants (static)
; * - all file local type definitions
; * - all file local variables (static)
; ****************************************************************************/
; #define nShortDelay             20              /* Verzgerungszeit fr I2C */
; 
; 
; /***************************************************************************
; *   Variablendefinitionen
; ****************************************************************************/
; 
; 
; /***************************************************************************
; *   Definition der einzelnen I2C-Befehle
; ****************************************************************************/
; #define _0  0xb0
; #define _1  0xb1
; #define _2  0xb2
; #define _3  0xb3
; #define _4  0xb4
; #define _5  0xb5
; #define _6  0xb6
; #define _7  0xb7
; #define _8  0xb8
; #define _9  0xb9
; 
; const byte abInit[]    = {0x74, 0x00, 0x25, 0x06, 0x24, 0x0f, 0x84};
; const byte abCls[]     = {0x74, 0x00, 0x84};
; const byte abText1[]   = {0x74, 0x40, 0xe3, 0xa7, 0xf4, 0xad, 0xd2, 0xef, 0xe2};
; const byte abZeile2[]  = {0x74, 0x00, 0xc4};
; const byte abNr0[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _0};
; const byte abNr1[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _1};
; const byte abNr2[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _2};
; const byte abNr3[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _3};
; const byte abNr4[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _4};
; const byte abNr5[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _5};
; const byte abNr6[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _6};
; const byte abNr7[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _7};
; const byte abNr8[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _8};
; const byte abNr9[]     = {0x74, 0x40, 0xd3, 0xf4, 0xe1, 0xf4, 0xe5, 0xa0, _9};
;  
; 
; /*****************************************************************************
;     Name:           vStarti2c()
;     Parameters:     none
;     Returns:        nothing
;     Description:    Generiert das Startsignal fr I2C-Bus
; 
; ******************************************************************************/
; void vStarti2c(void){
	.dbline 84
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 85
;      SDA();                             /* data high */
	or.b #8,&0x35
	.dbline 86
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 87
;      SCL();                             /* clk high */
	or.b #4,&0x35
	.dbline 88
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 89
;      _SDA();                            /* data low */
	and.b #-9,&0x35
	.dbline 90
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 91
;      _SCL();                            /* clk low */
	and.b #-5,&0x35
	.dbline 92
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline -2
	.dbline 93
;      }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vStopi2c _vStopi2c fV
	.even
_vStopi2c::
	.dbline -1
	.dbline 102
; 
; /*****************************************************************************
;     Name:           vStopi2c()
;     Parameters:     none
;     Returns:        nothing
;     Description:    Generiert das Stopsignal fr I2C-Bus
; 
; ******************************************************************************/
; void vStopi2c(void){
	.dbline 103
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 104
;      _SDA();                            /* data low */
	and.b #-9,&0x35
	.dbline 105
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 106
;      SCL();                             /* clk high */
	or.b #4,&0x35
	.dbline 107
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 108
;      SDA();                             /* data high */
	or.b #8,&0x35
	.dbline 109
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline -2
	.dbline 110
;      }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e vWriteBi2c _vWriteBi2c fV
;              i -> R5
;          bData -> R4
	.even
_vWriteBi2c::
	push R4
	push R5
	mov R14,R4
	.dbline -1
	.dbline 120
; 
; 
; /*****************************************************************************
;     Name:           vWriteBi2c()
;     Parameters:     Byte
;     Returns:        nothing
;     Description:    Schreibt in Byte auf den I2C-Bus
; 
; ******************************************************************************/
; void vWriteBi2c(byte bData){
	.dbline 121
;      byte i = 0;
	mov.b #0,R5
	.dbline 122
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 123
;      _SCL();
	and.b #-5,&0x35
	.dbline 124
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 125
	jmp L7
L4:
	.dbline 125
;      for ( i = 0; i < 8; i++){
	.dbline 126
;           if ((bData & 0x80) == 0x80){
	bit.b #128,R4
	jeq L8
	.dbline 126
	.dbline 127
;                SDA();                   /* Bit := 1 */
	or.b #8,&0x35
	.dbline 128
;                }
	jmp L9
L8:
	.dbline 129
;           else{
	.dbline 130
;                _SDA();                  /* Bit := 0 */
	and.b #-9,&0x35
	.dbline 131
;                }
L9:
	.dbline 132
	.dbline 133
	add.b R4,R4
	mov.b #20,R14
	call #_vDelay
	.dbline 134
	or.b #4,&0x35
	.dbline 135
	mov.b #20,R14
	call #_vDelay
	.dbline 136
	and.b #-5,&0x35
	.dbline 137
	mov.b #20,R14
	call #_vDelay
	.dbline 138
L5:
	.dbline 125
	add.b #1,R5
L7:
	.dbline 125
	cmp.b #8,R5
	jlo L4
	.dbline 139
;           bData <<= 1;
;           vDelay(nShortDelay);
;           SCL();
;           vDelay(nShortDelay);
;           _SCL();
;           vDelay(nShortDelay);
;           }
;      _SDA();
	and.b #-9,&0x35
	.dbline 140
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 141
;      SCL();
	or.b #4,&0x35
	.dbline 142
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline 143
;      _SCL();
	and.b #-5,&0x35
	.dbline 144
;      vDelay(nShortDelay);
	mov.b #20,R14
	call #_vDelay
	.dbline -2
	.dbline 145
;      }
L3:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 5 c
	.dbsym r bData 4 c
	.dbend
	.dbfunc e vDelay _vDelay fV
;          bTime -> R14
	.even
_vDelay::
	.dbline -1
	.dbline 154
; 
; /*****************************************************************************
;     Name:           vDelay()
;     Parameters:     Byte
;     Returns:        nothing
;     Description:    Laufzeitschleife
; 
; ******************************************************************************/
; void vDelay(byte bTime){
	jmp L12
L11:
	.dbline 155
	.dbline 156
	sub.b #1,R14
	.dbline 157
L12:
	.dbline 155
;      while(bTime){
	cmp.b #0,R14
	jne L11
	.dbline -2
	.dbline 158
;           bTime--;
;           }
;      }
L10:
	.dbline 0 ; func end
	ret
	.dbsym r bTime 14 c
	.dbend
	.dbfunc e vSendI2C _vSendI2C fV
;              w -> R6
;           pStr -> R5
;           bLen -> R4
	.even
_vSendI2C::
	push R4
	push R5
	push R6
	mov R15,R5
	mov R14,R4
	.dbline -1
	.dbline 167
; 
; /*****************************************************************************
;     Name:           vSendI2C()
;     Parameters:     Zeichenanzahl, String
;     Returns:        nothing
;     Description:    Schickt den String zum I2C Bus
; 
; ******************************************************************************/
; void vSendI2C(byte bLen, byte *pStr){
	.dbline 168
;      word w = 500;
	mov #500,R6
L15:
	.dbline 169
L16:
	.dbline 169
;      while(w--);
	mov R6,r13
	sub #1,R6
	cmp #0,r13
	jne L15
	.dbline 170
;      vStarti2c();
	call #_vStarti2c
	jmp L19
L18:
	.dbline 171
	.dbline 172
	mov.b @R5,R14
	call #_vWriteBi2c
	.dbline 173
	.dbline 174
	add #1,R5
	sub.b #1,R4
	.dbline 175
L19:
	.dbline 171
;      while(bLen){
	cmp.b #0,R4
	jne L18
	.dbline 176
;           vWriteBi2c(*pStr);
;           pStr++;
;           bLen--;
;           }
;      vStopi2c();
	call #_vStopi2c
	.dbline -2
	.dbline 177
;      }
L14:
	pop R6
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r w 6 i
	.dbsym r pStr 5 pc
	.dbsym r bLen 4 c
	.dbend
	.dbfunc e I2C_vInit _I2C_vInit fV
	.even
_I2C_vInit::
	.dbline -1
	.dbline 185
; 
; /***************************************************************************
; * Kurzbeschreibung     : OV6620 (OV6630) initialisieren
; * Uebergabeparameter   : --
; * Return Value         : --
; * Author               : Jens Altenburg
; ****************************************************************************/
; void I2C_vInit( void ){
	.dbline 186
;      vSendI2C(sizeof(abInit),   (byte *) &abInit[0]);
	mov #_abInit,R15
	mov.b #7,R14
	call #_vSendI2C
	.dbline 187
;      vSendI2C(sizeof(abCls),    (byte *) &abCls[0]);
	mov #_abCls,R15
	mov.b #3,R14
	call #_vSendI2C
	.dbline 188
;      vSendI2C(sizeof(abText1),  (byte *) &abText1[0]);
	mov #_abText1,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 189
;      vSendI2C(sizeof(abZeile2), (byte *) &abZeile2[0]);
	mov #_abZeile2,R15
	mov.b #3,R14
	call #_vSendI2C
	.dbline 190
;      vSendI2C(sizeof(abNr0),    (byte *) &abNr0[0]);
	mov #_abNr0,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline -2
	.dbline 191
;      }
L21:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_vState _I2C_vState fV
;         bState -> R5
	.even
_I2C_vState::
	push R4
	push R5
	mov R14,R5
	.dbline -1
	.dbline 193
;      
; void I2C_vState(byte bState){
	.dbline 194
;      vSendI2C(sizeof(abZeile2), (byte *) &abZeile2[0]);
	mov #_abZeile2,R15
	mov.b #3,R14
	call #_vSendI2C
	.dbline 195
	mov R5,R4
	and #255,R4
	cmp #0,R4
	jeq L26
	cmp #1,R4
	jeq L27
	cmp #2,R4
	jeq L28
	cmp #3,R4
	jeq L29
	cmp #4,R4
	jeq L30
	cmp #5,R4
	jeq L31
	cmp #6,R4
	jeq L32
	cmp #7,R4
	jeq L33
	cmp #8,R4
	jeq L34
	cmp #9,R4
	jeq L35
	jmp L23
X0:
	.dbline 195
;      switch(bState){
L26:
	.dbline 197
;         case 0:
;             vSendI2C(sizeof(abNr0),    (byte *) &abNr0[0]);
	mov #_abNr0,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 198
;             break;
	jmp L24
L27:
	.dbline 200
;         case 1:
;             vSendI2C(sizeof(abNr1),    (byte *) &abNr1[0]);
	mov #_abNr1,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 201
;             break;
	jmp L24
L28:
	.dbline 203
;         case 2:
;             vSendI2C(sizeof(abNr2),    (byte *) &abNr2[0]);
	mov #_abNr2,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 204
;             break;
	jmp L24
L29:
	.dbline 206
;         case 3:
;             vSendI2C(sizeof(abNr3),    (byte *) &abNr3[0]);
	mov #_abNr3,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 207
;             break;
	jmp L24
L30:
	.dbline 209
;         case 4:
;             vSendI2C(sizeof(abNr4),    (byte *) &abNr4[0]);
	mov #_abNr4,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 210
;             break;
	jmp L24
L31:
	.dbline 212
;         case 5:
;             vSendI2C(sizeof(abNr5),    (byte *) &abNr5[0]);
	mov #_abNr5,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 213
;             break;
	jmp L24
L32:
	.dbline 215
;         case 6:
;             vSendI2C(sizeof(abNr6),    (byte *) &abNr6[0]);
	mov #_abNr6,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 216
;             break;
	jmp L24
L33:
	.dbline 218
;         case 7:
;             vSendI2C(sizeof(abNr7),    (byte *) &abNr7[0]);
	mov #_abNr7,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 219
;             break;
	jmp L24
L34:
	.dbline 221
;         case 8:
;             vSendI2C(sizeof(abNr8),    (byte *) &abNr8[0]);
	mov #_abNr8,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 222
;             break;
	jmp L24
L35:
	.dbline 224
;         case 9:
;             vSendI2C(sizeof(abNr9),    (byte *) &abNr9[0]);
	mov #_abNr9,R15
	mov.b #9,R14
	call #_vSendI2C
	.dbline 225
;             break;
L23:
L24:
	.dbline -2
	.dbline 227
;         }
;     }            
L22:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r bState 5 c
	.dbend
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
