	.module smd.c
	.area lit
_abHalfPattern::
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.byte 0,0
	.dbfile C:\projekte\msp430\ct05\smd.c
	.dbsym e abHalfPattern _abHalfPattern A[8:8]c
_abFullPattern::
	.byte 0,2
	.byte 3,1
	.byte 0,2
	.byte 3,1
	.dbsym e abFullPattern _abFullPattern A[8:8]c
	.area text
	.dbfile C:\projekte\msp430\ct05\smd.c
	.dbfunc e vSmdDummy _vSmdDummy fV
;              i -> R4
	.even
_vSmdDummy::
	push R4
	.dbline -1
	.dbline 148
; /***************************************************************************
; * Titel        : SMD.C
; *
; * Description  : Ansteuerung fr zwei Schrittmotoren
; *
; * Environment  :
; *
; * Responsible  : J. Altenburg
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   20.02.04 |J. Altenburg     | Ersterstellung
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)                   *
; ****************************************************************************/
; /* System-headerfiles */
; #include "cdef.h"                      /* General definitions and types */
; 
; /* Own headerfiles */
; #include "smd.h"
; 
; /* Foreign headerfiles */
; #include <stdlib.h>
; 
; /***************************************************************************
; *    Konstaten                                                             *
; ****************************************************************************/
; /* Achtung: Halbschritt ist nicht implementiert */
; const byte abHalfPattern[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
; const byte abFullPattern[] = {0x00, 0x02, 0x03, 0x01, 0x00, 0x02, 0x03, 0x01};
; 
; #define nTableSize       7              /* Gre der Bitmustertabelle */
; #define nSmdMask         0x03
; #define mcSetDriverL(x)  (P1OUT = (P1OUT & ~nSmdMask) | x)
; #define mcSetDriverR(x)  (P2OUT = (P2OUT & ~nSmdMask) | x)
; #define nRampSize        8
; #define nSmdLowSpeed     50000          /* niedrige Geschwindigkeit */
; #define nSmdHighSpeed    15000          /* Hchstgeschwindigkeit */
; 
; /***************************************************************************
; *    Variablen                                                             *
; ****************************************************************************/
; byte bSmdStateL; /*
; * Description : Variable fr Zustandsautomat
; */
; 
; byte bSmdStateR; /*
; * Description : Variable fr Zustandsautomat
; */
; 
; fCallBackSmd fSmdFuncL; /*
; * Description : Callbackfunktion fr Benachrichtigung
; */
; 
; fCallBackSmd fSmdFuncR; /*
; * Description : Callbackfunktion fr Benachrichtigung
; */
; 
; const byte *pBitMusterL; /*
; * Description : Index auf Bitmuster
; */
; 
; const byte *pBitMusterR; /*
; * Description : Index auf Bitmuster
; */
; 
; byte bRampL; /*
; * Description : Index auf Rampe
; */
; 
; byte bRampR; /*
; * Description : Index auf Rampe
; */
; 
; dword dwStepsL; /*
; * Description : Schrittzahl
; */
; 
; dword dwStepsR; /*
; * Description : Schrittzahl
; */
; 
; int8 i8DirL; /*
; * Description : Decrement/Increment
; */
; 
; int8 i8DirR; /*
; * Description : Decrement/Increment
; */
; 
; byte bSmdCountL; /*
; * Description : Schrittzhler
; */
; 
; byte bSmdCountR; /*
; * Description : Schrittzhler
; */
; 
; word awRampL[nRampSize]; /*
; * Description : Beschleunigung/Bremsung
; */
; 
; word awRampR[nRampSize]; /*
; * Description : Beschleunigung/Bremsung
; */
; 
; /* Zugriffsmakros fr Merkflags */
; 
; 
; 
; /**********************************************************************
; * Defines und Makros Zugriff                                               *
; ****************************************************************************/
; enum {
;      enSmdInit = 0,                /* tut nix */
;      enSmdPrep1,                   /* Start-Stop vorbereiten */
;      enSmdPrep2,                   /* Normalmode vorbereiten */
;      enSmdStartStop,               /* Start-Stop-Mode */
;      enSmdRampUp,                  /* Beschleunigung */
;      enSmdMove,                    /* Drehung */
;      enSmdRampDown,                /* Bremsen */
;      };
; 
; #define mcPowerOnL()       (P1OUT &= ~0xfc)
; #define mcPowerOffL()      (P1OUT |=  0xd8)
; 
; #define mcPowerOnR()       (P2OUT &= ~0xfc)
; #define mcPowerOffR()      (P2OUT |=  0xd8)
; 
; 
; /***************************************************************************
; *    Code                                                                  *
; ****************************************************************************/
; 
; /***************************************************************************
; *    Funktion: Dummy fr Benachrichtigungsfunktion                         *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void vSmdDummy( void ){
	.dbline 150
;       byte i;
;       i++;        /* */
	add.b #1,R4
	.dbline -2
	.dbline 151
;       }
L2:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 4 c
	.dbend
	.dbfunc e SMD_vCritical _SMD_vCritical fV
	.even
_SMD_vCritical::
	.dbline -1
	.dbline 157
; 
; /***************************************************************************
; *    Funktion: Not-Aus, Motor wird sofort gestoppt                         *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void SMD_vCritical( void ){
	.dbline -2
	.dbline 159
; 
;      }
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SMD_vInit _SMD_vInit fV
	.even
_SMD_vInit::
	.dbline -1
	.dbline 165
; 
; /***************************************************************************
; *    Funktion: Initialisierung                                             *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void SMD_vInit( void ){
	.dbline 166
;      fSmdFuncL = vSmdDummy;                   /* Callbackfunktion initialisieren */
	.dbline 167
;      bSmdStateL = enSmdInit;
	.dbline 168
;      fSmdFuncR = vSmdDummy;                   /* Callbackfunktion initialisieren */
	.dbline 169
;      bSmdStateR = enSmdInit;
	mov #_vSmdDummy,R13
	mov R13,_fSmdFuncL
	mov.b #0,_bSmdStateL
	mov R13,_fSmdFuncR
	mov.b #0,_bSmdStateR
	.dbline -2
	.dbline 170
;      }
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SMD_vStartL _SMD_vStartL fV
;              w -> R4
;              i -> R5
;             iW -> 10(SP)
;           wMax -> R5
;           bTyp -> R4
;           fSmd -> R6
	.even
_SMD_vStartL::
	push R4
	push R5
	push R6
	mov R15,R4
	mov R14,R6
	mov 8(R1),R5
	.dbline -1
	.dbline 186
; 
; 
; 
; /***************************************************************************
; *    Funktion: Kommunikationsinterface zum Schrittmotortreiber             *
; *              - Benachritigungsfunktion initialisieren                    *
; *              - Bewegungsmode einstellen                                  *
; *              - Hochlaufkurve berechnen                                   *
; *              - Schrittzahl einstellen                                    *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void SMD_vStartL( fCallBackSmd fSmd,    /* Benachrichtigung */
;                   byte bTyp,            /* Bewegungstyp, Halbschritt, Vollschritt */
;                   word wMax,            /* Maximalgeschwindigkeit */
;                   int32 iW              /* Schrittzahl, Vorzeichen = Drehrichtung */
;                 ){
	.dbline 189
;      word w;
;      byte i;     
;      fSmdFuncL = fSmd;                   /* Benachrichtigungsfunktion */
	.dbline 190
;      if(iW == 0){
	mov R6,_fSmdFuncL
	mov #0,R14
	mov #0,R15
	push 14(R1)
	push 14(R1)
	call #cmp32
	jne L6
	.dbline 190
	.dbline 191
;            fSmdFuncL();
	call _fSmdFuncL
	.dbline 192
;            return;                      /* Schrittzahl 0 abfangen */
	jmp L5
L6:
	.dbline 194
;            }
;      if(iW >= 0){                       /* Drehrichtung festlegen */
	mov 10(R1),R14
	mov 12(R1),R15
	push #0
	push #0
	call #cmp32
	jl L8
	.dbline 194
	.dbline 195
;           dwStepsL = iW;
	.dbline 196
;           i8DirL = 1;
	mov 10(R1),_dwStepsL
	mov 12(R1),_dwStepsL+2
	mov.b #1,_i8DirL
	.dbline 197
;           }
	jmp L9
L8:
	.dbline 198
;      else {
	.dbline 199
;           dwStepsL = abs(iW);
	.dbline 200
;           i8DirL = -1;
	mov R1,R13
	add #10,R13
	mov @R13,R12
	mov R12,R14
	call #_abs
	mov R14,r13
	mov r14,R12
	clr R13
	tst R12
	jge X0
	inv R13
X0:
	mov R12,_dwStepsL
	mov R13,_dwStepsL+2
	mov.b #-1,_i8DirL
	.dbline 201
;           }
L9:
	.dbline 202
;      if(bTyp){                          /* Unterscheidung Halb/Vollschritt */
	cmp.b #0,R4
	jeq L10
	.dbline 202
	.dbline 203
;           pBitMusterL = &abHalfPattern[0];
	mov #_abHalfPattern,R13
	mov R13,_pBitMusterL
	.dbline 204
;           }
	jmp L11
L10:
	.dbline 205
;      else {
	.dbline 206
;           pBitMusterL = &abFullPattern[0];
	mov #_abFullPattern,R13
	mov R13,_pBitMusterL
	.dbline 207
;           }
L11:
	.dbline 209
;      /* Hochlauframpe berechnen */
;      if(wMax < nSmdHighSpeed) wMax = nSmdHighSpeed; /* Maximalgeschwindigkeit begrenzen */
	cmp #15000,R5
	jhs L12
	.dbline 209
	mov #15000,R5
L12:
	.dbline 210
;      if(wMax > (nSmdLowSpeed - nRampSize)){
	mov #49992,R13
	cmp R5,R13
	jhs L14
	.dbline 210
	.dbline 211
;           wMax = nSmdLowSpeed - nRampSize;
	mov R13,R5
	.dbline 212
;           }
L14:
	.dbline 213
;      if(dwStepsL < (2 * nRampSize)){     /* nur Start-Stop Geschwindigkeit */
	mov _dwStepsL,R14
	mov _dwStepsL+2,R15
	push #0
	push #16
	call #cmp32
	jhs L16
	.dbline 213
	.dbline 214
;           awRampL[0] = nSmdLowSpeed;
	.dbline 215
;           bSmdStateL = enSmdPrep1;       /* Bewegung vorbereiten */
	mov #50000,_awRampL
	mov.b #1,_bSmdStateL
	.dbline 216
;           }
	jmp L17
L16:
	.dbline 217
;      else {
	.dbline 218
;           w = nSmdLowSpeed - wMax;      /* Differenzgeschwindigkeit */
	.dbline 219
;           w = w / nRampSize;            /* Geschwindigkeitsschritte */
	.dbline 220
	mov #50000,R4
	sub R5,R4
	clrc
	rrc R4
	rra R4
	rra R4
	mov.b #0,R5
	jmp L21
L18:
	.dbline 220
	.dbline 221
	mov R5,R13
	and #255,R13
	add #1,R13
	push SR
	dint
	nop
	mov R4,&0x130
	mov R13,&0x138
	mov &0x13A,R13
	pop SR
	mov #50000,R12
	sub R13,R12
	mov #_awRampL,R13
	mov R5,R11
	and #255,R11
	add R11,R11
	add R13,R11
	mov R12,0(R11)
	.dbline 222
L19:
	.dbline 220
	add.b #1,R5
L21:
	.dbline 220
	cmp.b #8,R5
	jlo L18
	.dbline 223
	.dbline 224
	mov _dwStepsL,R12
	mov _dwStepsL+2,R13
	sub #16,R12
	subc #0,R13
	mov R12,_dwStepsL
	mov R13,_dwStepsL+2
	mov.b #2,_bSmdStateL
	.dbline 225
L17:
	.dbline -2
	.dbline 226
;           for(i = 0; i < nRampSize; i++){
;                awRampL[i] = nSmdLowSpeed - w * (i + 1);
;                }
;           dwStepsL -= 2 * nRampSize;     /* Schritte mit Hchstgeschwindigkeit */
;           bSmdStateL = enSmdPrep2;       /* Bewegung vorbereiten */
;           }
;      }
L5:
	pop R6
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r w 4 i
	.dbsym r i 5 c
	.dbsym l iW 10 L
	.dbsym r wMax 5 i
	.dbsym r bTyp 4 c
	.dbsym r fSmd 6 pfV
	.dbend
	.dbfunc e SMD_wMoveL _SMD_wMoveL fi
;              i -> R5
;          wTime -> R4
	.even
_SMD_wMoveL::
	push R4
	push R5
	.dbline -1
	.dbline 234
; 
; 
; /***************************************************************************
; *    Funktion: Interruptservive-Funktion zur Motorsteuerung                *
; *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; word SMD_wMoveL ( void ){                    /* Bewegungserzeugung */
	.dbline 237
	mov.b _bSmdStateL,R4
	and #255,R4
	cmp #0,R4
	jeq L26
	cmp #1,R4
	jeq L27
	cmp #2,R4
	jeq L28
	cmp #3,R4
	jeq L29
	cmp #4,R4
	jeq L32
	cmp #5,R4
	jeq L35
	cmp #6,R4
	jeq L39
	jmp L23
X1:
	.dbline 237
;      byte i;
;      word wTime;
;      switch(bSmdStateL){
L26:
	.dbline 239
;           case enSmdInit:                    /* tut nix */
;                mcPowerOffL();                 /* Haltestrom einstellen */
	or.b #216,&0x21
	.dbline 240
;                wTime = nSmdLowSpeed;         /* Zeitspanne bis zum nchsten Aufruf */
	mov #50000,R4
	.dbline 241
;                break;
	jmp L24
L27:
	.dbline 243
;           case enSmdPrep1:                   /* Start-Stop vorbereiten */
;                mcPowerOnL();
	and.b #-253,&0x21
	.dbline 244
;                wTime = awRampL[0];            /* Zeit aus Rampentabelle */
	.dbline 245
;                bSmdStateL = enSmdStartStop;
	mov _awRampL,R4
	mov.b #3,_bSmdStateL
	.dbline 246
;                break;
	jmp L24
L28:
	.dbline 248
;           case enSmdPrep2:                   /* Normalmode vorbereiten */
;                mcPowerOnL();
	and.b #-253,&0x21
	.dbline 249
;                wTime = awRampL[0];
	.dbline 250
;                bRampL = 0;
	.dbline 251
;                bSmdStateL = enSmdRampUp;
	mov _awRampL,R4
	mov.b #0,_bRampL
	mov.b #4,_bSmdStateL
	.dbline 252
;                break;
	jmp L24
L29:
	.dbline 254
;           case enSmdStartStop:               /* Start-Stop-Mode */
;                i = bSmdCountL & nTableSize;   /* Offset fr Zeiger auf Tabelle begrenzen */
	.dbline 255
;                mcSetDriverL(*(pBitMusterL+i));
	mov.b _bSmdCountL,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterL,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x21,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x21
	.dbline 256
;                bSmdCountL += i8DirL;           /* nchster Schritt */
	.dbline 257
;                dwStepsL--;
	.dbline 258
;                if(dwStepsL == 0){
	add.b _i8DirL,_bSmdCountL
	mov _dwStepsL,R12
	mov _dwStepsL+2,R13
	sub #1,R12
	subc #0,R13
	mov R12,_dwStepsL
	mov R13,_dwStepsL+2
	mov #0,R14
	mov #0,R15
	push _dwStepsL+2
	push _dwStepsL
	call #cmp32
	jne L30
	.dbline 258
	.dbline 259
;                       bSmdStateL = enSmdInit;
	.dbline 260
;                       fSmdFuncL();
	mov.b #0,_bSmdStateL
	call _fSmdFuncL
	.dbline 261
;                       }
L30:
	.dbline 262
;                wTime = awRampL[0];            /* Schrittzeit */
	mov _awRampL,R4
	.dbline 263
;                break;
	jmp L24
L32:
	.dbline 265
;           case enSmdRampUp:                  /* Beschleunigung */
;                i = bSmdCountL & nTableSize;   /* Zeiger auf Bitmuster berechnen */
	.dbline 266
;                mcSetDriverL(*(pBitMusterL+i));
	mov.b _bSmdCountL,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterL,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x21,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x21
	.dbline 267
;                bSmdCountL += i8DirL;           /* nchster Schritt */
	.dbline 268
;                bRampL++;
	.dbline 269
;                wTime = awRampL[bRampL];
	.dbline 270
;                if(bRampL >= nRampSize - 1) bSmdStateL = enSmdMove;
	add.b _i8DirL,_bSmdCountL
	add.b #1,_bRampL
	mov.b _bRampL,r13
	mov #_awRampL,R12
	mov r13,R11
	and #255,R11
	add R11,R11
	add R12,R11
	mov @R11,R4
	cmp.b #7,r13
	jlo L24
	.dbline 270
	mov.b #5,_bSmdStateL
	.dbline 271
;                break;
	jmp L24
L35:
	.dbline 273
;           case enSmdMove:                    /* Drehung */
;                i = bSmdCountL & nTableSize;   /* Zeiger auf Bitmuster berechnen */
	.dbline 274
;                mcSetDriverL(*(pBitMusterL+i));
	mov.b _bSmdCountL,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterL,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x21,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x21
	.dbline 275
;                bSmdCountL += i8DirL;           /* nchster Schritt */
	.dbline 276
;                dwStepsL--;
	.dbline 277
;                if(dwStepsL == 0) bSmdStateL = enSmdRampDown;
	add.b _i8DirL,_bSmdCountL
	mov _dwStepsL,R12
	mov _dwStepsL+2,R13
	sub #1,R12
	subc #0,R13
	mov R12,_dwStepsL
	mov R13,_dwStepsL+2
	mov #0,R14
	mov #0,R15
	push _dwStepsL+2
	push _dwStepsL
	call #cmp32
	jne L36
	.dbline 277
	mov.b #6,_bSmdStateL
L36:
	.dbline 278
;                wTime = awRampL[nRampSize - 1];
	mov _awRampL+14,R4
	.dbline 279
;                break;
	jmp L24
L39:
	.dbline 281
;           case enSmdRampDown:                /* Bremsen */
;                i = bSmdCountL & nTableSize;   /* Zeiger auf Bitmuster berechnen */
	.dbline 282
;                mcSetDriverL(*(pBitMusterL+i));
	mov.b _bSmdCountL,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterL,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x21,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x21
	.dbline 283
;                bSmdCountL += i8DirL;           /* nchster Schritt */
	.dbline 284
;                bRampL--;
	.dbline 285
;                wTime = awRampL[bRampL];
	.dbline 286
;                if(bRampL == 0){
	add.b _i8DirL,_bSmdCountL
	sub.b #1,_bRampL
	mov.b _bRampL,r13
	mov #_awRampL,R12
	mov r13,R11
	and #255,R11
	add R11,R11
	add R12,R11
	mov @R11,R4
	cmp.b #0,r13
	jne L24
	.dbline 286
	.dbline 287
;                     bSmdStateL = enSmdInit;
	.dbline 288
;                     fSmdFuncL();              /* Motorbewegung ist beendet */
	mov.b #0,_bSmdStateL
	call _fSmdFuncL
	.dbline 289
;                     }
	.dbline 290
;                break;
L23:
L24:
	.dbline 292
;           }
;      return wTime;
	mov R4,R14
	.dbline -2
L22:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 5 c
	.dbsym r wTime 4 i
	.dbend
	.dbfunc e SMD_vStartR _SMD_vStartR fV
;              w -> R4
;              i -> R5
;             iW -> 10(SP)
;           wMax -> R5
;           bTyp -> R4
;           fSmd -> R6
	.even
_SMD_vStartR::
	push R4
	push R5
	push R6
	mov R15,R4
	mov R14,R6
	mov 8(R1),R5
	.dbline -1
	.dbline 309
;      }
; 
; 
; 
; /***************************************************************************
; *    Funktion: Kommunikationsinterface zum Schrittmotortreiber             *
; *              - Benachritigungsfunktion initialisieren                    *
; *              - Bewegungsmode einstellen                                  *
; *              - Hochlaufkurve berechnen                                   *
; *              - Schrittzahl einstellen                                    *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; void SMD_vStartR( fCallBackSmd fSmd,    /* Benachrichtigung */
;                   byte bTyp,            /* Bewegungstyp, Halbschritt, Vollschritt */
;                   word wMax,            /* Maximalgeschwindigkeit */
;                   int32 iW              /* Schrittzahl, Vorzeichen = Drehrichtung */
;                 ){
	.dbline 312
;      word w;
;      byte i;
;      fSmdFuncR = fSmd;
	.dbline 313
;      if(iW == 0){
	mov R6,_fSmdFuncR
	mov #0,R14
	mov #0,R15
	push 14(R1)
	push 14(R1)
	call #cmp32
	jne L43
	.dbline 313
	.dbline 314
;            fSmdFuncR();
	call _fSmdFuncR
	.dbline 315
;            return;                      /* Schrittzahl 0 abfangen */
	jmp L42
L43:
	.dbline 317
;            }
;      if(iW >= 0){                       /* Drehrichtung festlegen */
	mov 10(R1),R14
	mov 12(R1),R15
	push #0
	push #0
	call #cmp32
	jl L45
	.dbline 317
	.dbline 318
;           dwStepsR = iW;
	.dbline 319
;           i8DirR = 1;
	mov 10(R1),_dwStepsR
	mov 12(R1),_dwStepsR+2
	mov.b #1,_i8DirR
	.dbline 320
;           }
	jmp L46
L45:
	.dbline 321
;      else {
	.dbline 322
;           dwStepsR = abs(iW);
	.dbline 323
;           i8DirR = -1;
	mov R1,R13
	add #10,R13
	mov @R13,R12
	mov R12,R14
	call #_abs
	mov R14,r13
	mov r14,R12
	clr R13
	tst R12
	jge X2
	inv R13
X2:
	mov R12,_dwStepsR
	mov R13,_dwStepsR+2
	mov.b #-1,_i8DirR
	.dbline 324
;           }
L46:
	.dbline 325
;      if(bTyp){                          /* Unterscheidung Halb/Vollschritt */
	cmp.b #0,R4
	jeq L47
	.dbline 325
	.dbline 326
;           pBitMusterR = &abHalfPattern[0];
	mov #_abHalfPattern,R13
	mov R13,_pBitMusterR
	.dbline 327
;           }
	jmp L48
L47:
	.dbline 328
;      else {
	.dbline 329
;           pBitMusterR = &abFullPattern[0];
	mov #_abFullPattern,R13
	mov R13,_pBitMusterR
	.dbline 330
;           }
L48:
	.dbline 332
;      /* Hochlauframpe berechnen */
;      if(wMax < nSmdHighSpeed) wMax = nSmdHighSpeed; /* Maximalgeschwindigkeit begrenzen */
	cmp #15000,R5
	jhs L49
	.dbline 332
	mov #15000,R5
L49:
	.dbline 333
;      if(wMax > (nSmdLowSpeed - nRampSize)){
	mov #49992,R13
	cmp R5,R13
	jhs L51
	.dbline 333
	.dbline 334
;           wMax = nSmdLowSpeed - nRampSize;
	mov R13,R5
	.dbline 335
;           }
L51:
	.dbline 336
;      if(dwStepsR < (2 * nRampSize)){     /* nur Start-Stop Geschwindigkeit */
	mov _dwStepsR,R14
	mov _dwStepsR+2,R15
	push #0
	push #16
	call #cmp32
	jhs L53
	.dbline 336
	.dbline 337
;           awRampR[0] = nSmdLowSpeed;
	.dbline 338
;           bSmdStateR = enSmdPrep1;       /* Bewegung vorbereiten */
	mov #50000,_awRampR
	mov.b #1,_bSmdStateR
	.dbline 339
;           }
	jmp L54
L53:
	.dbline 340
;      else {
	.dbline 341
;           w = nSmdLowSpeed - wMax;      /* Differenzgeschwindigkeit */
	.dbline 342
;           w = w / nRampSize;            /* Geschwindigkeitsschritte */
	.dbline 343
	mov #50000,R4
	sub R5,R4
	clrc
	rrc R4
	rra R4
	rra R4
	mov.b #0,R5
	jmp L58
L55:
	.dbline 343
	.dbline 344
	mov R5,R13
	and #255,R13
	add #1,R13
	push SR
	dint
	nop
	mov R4,&0x130
	mov R13,&0x138
	mov &0x13A,R13
	pop SR
	mov #50000,R12
	sub R13,R12
	mov #_awRampR,R13
	mov R5,R11
	and #255,R11
	add R11,R11
	add R13,R11
	mov R12,0(R11)
	.dbline 345
L56:
	.dbline 343
	add.b #1,R5
L58:
	.dbline 343
	cmp.b #8,R5
	jlo L55
	.dbline 346
	.dbline 347
	mov _dwStepsR,R12
	mov _dwStepsR+2,R13
	sub #16,R12
	subc #0,R13
	mov R12,_dwStepsR
	mov R13,_dwStepsR+2
	mov.b #2,_bSmdStateR
	.dbline 348
L54:
	.dbline -2
	.dbline 349
;           for(i = 0; i < nRampSize; i++){
;                awRampR[i] = nSmdLowSpeed - w * (i + 1);
;                }
;           dwStepsR -= 2 * nRampSize;     /* Schritte mit Hchstgeschwindigkeit */
;           bSmdStateR = enSmdPrep2;       /* Bewegung vorbereiten */
;           }
;      }
L42:
	pop R6
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r w 4 i
	.dbsym r i 5 c
	.dbsym l iW 10 L
	.dbsym r wMax 5 i
	.dbsym r bTyp 4 c
	.dbsym r fSmd 6 pfV
	.dbend
	.dbfunc e SMD_wMoveR _SMD_wMoveR fi
;              i -> R5
;          wTime -> R4
	.even
_SMD_wMoveR::
	push R4
	push R5
	.dbline -1
	.dbline 357
; 
; 
; /***************************************************************************
; *    Funktion: Interruptservive-Funktion zur Motorsteuerung                *
; *                                                                          *
; *    Autor:    Jens Altenburg                                              *
; ****************************************************************************/
; word SMD_wMoveR ( void ){                    /* Bewegungserzeugung */
	.dbline 360
	mov.b _bSmdStateR,R4
	and #255,R4
	cmp #0,R4
	jeq L63
	cmp #1,R4
	jeq L64
	cmp #2,R4
	jeq L65
	cmp #3,R4
	jeq L66
	cmp #4,R4
	jeq L69
	cmp #5,R4
	jeq L72
	cmp #6,R4
	jeq L76
	jmp L60
X3:
	.dbline 360
;      byte i;
;      word wTime;
;      switch(bSmdStateR){
L63:
	.dbline 362
;           case enSmdInit:                    /* tut nix */
;                mcPowerOffR();                 /* Haltestrom einstellen */
	or.b #216,&0x29
	.dbline 363
;                wTime = nSmdLowSpeed;         /* Zeitspanne bis zum nchsten Aufruf */
	mov #50000,R4
	.dbline 364
;                break;
	jmp L61
L64:
	.dbline 366
;           case enSmdPrep1:                   /* Start-Stop vorbereiten */
;                mcPowerOnR();
	and.b #-253,&0x29
	.dbline 367
;                wTime = awRampR[0];            /* Zeit aus Rampentabelle */
	.dbline 368
;                bSmdStateR = enSmdStartStop;
	mov _awRampR,R4
	mov.b #3,_bSmdStateR
	.dbline 369
;                break;
	jmp L61
L65:
	.dbline 371
;           case enSmdPrep2:                   /* Normalmode vorbereiten */
;                mcPowerOnR();
	and.b #-253,&0x29
	.dbline 372
;                wTime = awRampR[0];
	.dbline 373
;                bRampR = 0;
	.dbline 374
;                bSmdStateR = enSmdRampUp;
	mov _awRampR,R4
	mov.b #0,_bRampR
	mov.b #4,_bSmdStateR
	.dbline 375
;                break;
	jmp L61
L66:
	.dbline 377
;           case enSmdStartStop:               /* Start-Stop-Mode */
;                i = bSmdCountR & nTableSize;   /* Offset fr Zeiger auf Tabelle begrenzen */
	.dbline 378
;                mcSetDriverR(*(pBitMusterR+i));
	mov.b _bSmdCountR,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterR,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x29,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x29
	.dbline 379
;                bSmdCountR += i8DirR;           /* nchster Schritt */
	.dbline 380
;                dwStepsR--;
	.dbline 381
;                if(dwStepsR == 0){
	add.b _i8DirR,_bSmdCountR
	mov _dwStepsR,R12
	mov _dwStepsR+2,R13
	sub #1,R12
	subc #0,R13
	mov R12,_dwStepsR
	mov R13,_dwStepsR+2
	mov #0,R14
	mov #0,R15
	push _dwStepsR+2
	push _dwStepsR
	call #cmp32
	jne L67
	.dbline 381
	.dbline 382
;                       bSmdStateR = enSmdInit;
	.dbline 383
;                       fSmdFuncR();
	mov.b #0,_bSmdStateR
	call _fSmdFuncR
	.dbline 384
;                       }
L67:
	.dbline 385
;                wTime = awRampR[0];            /* Schrittzeit */
	mov _awRampR,R4
	.dbline 386
;                break;
	jmp L61
L69:
	.dbline 388
;           case enSmdRampUp:                  /* Beschleunigung */
;                i = bSmdCountR & nTableSize;   /* Zeiger auf Bitmuster berechnen */
	.dbline 389
;                mcSetDriverR(*(pBitMusterR+i));
	mov.b _bSmdCountR,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterR,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x29,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x29
	.dbline 390
;                bSmdCountR += i8DirR;           /* nchster Schritt */
	.dbline 391
;                bRampR++;
	.dbline 392
;                wTime = awRampR[bRampR];
	.dbline 393
;                if(bRampR >= nRampSize - 1) bSmdStateR = enSmdMove;
	add.b _i8DirR,_bSmdCountR
	add.b #1,_bRampR
	mov.b _bRampR,r13
	mov #_awRampR,R12
	mov r13,R11
	and #255,R11
	add R11,R11
	add R12,R11
	mov @R11,R4
	cmp.b #7,r13
	jlo L61
	.dbline 393
	mov.b #5,_bSmdStateR
	.dbline 394
;                break;
	jmp L61
L72:
	.dbline 396
;           case enSmdMove:                    /* Drehung */
;                i = bSmdCountR & nTableSize;   /* Zeiger auf Bitmuster berechnen */
	.dbline 397
;                mcSetDriverR(*(pBitMusterR+i));
	mov.b _bSmdCountR,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterR,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x29,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x29
	.dbline 398
;                bSmdCountR += i8DirR;           /* nchster Schritt */
	.dbline 399
;                dwStepsR--;
	.dbline 400
;                if(dwStepsR == 0) bSmdStateR = enSmdRampDown;
	add.b _i8DirR,_bSmdCountR
	mov _dwStepsR,R12
	mov _dwStepsR+2,R13
	sub #1,R12
	subc #0,R13
	mov R12,_dwStepsR
	mov R13,_dwStepsR+2
	mov #0,R14
	mov #0,R15
	push _dwStepsR+2
	push _dwStepsR
	call #cmp32
	jne L73
	.dbline 400
	mov.b #6,_bSmdStateR
L73:
	.dbline 401
;                wTime = awRampR[nRampSize - 1];
	mov _awRampR+14,R4
	.dbline 402
;                break;
	jmp L61
L76:
	.dbline 404
;           case enSmdRampDown:                /* Bremsen */
;                i = bSmdCountR & nTableSize;   /* Zeiger auf Bitmuster berechnen */
	.dbline 405
;                mcSetDriverR(*(pBitMusterR+i));
	mov.b _bSmdCountR,R5
	and.b #7,R5
	mov R5,R13
	and #255,R13
	add _pBitMusterR,R13
	mov.b @R13,R13
	and #255,R13
	mov.b &0x29,R12
	and #252,R12
	or R13,R12
	mov R12,R13
	mov.b R13,&0x29
	.dbline 406
;                bSmdCountR += i8DirR;           /* nchster Schritt */
	.dbline 407
;                bRampR--;
	.dbline 408
;                wTime = awRampR[bRampR];
	.dbline 409
;                if(bRampR == 0){
	add.b _i8DirR,_bSmdCountR
	sub.b #1,_bRampR
	mov.b _bRampR,r13
	mov #_awRampR,R12
	mov r13,R11
	and #255,R11
	add R11,R11
	add R12,R11
	mov @R11,R4
	cmp.b #0,r13
	jne L61
	.dbline 409
	.dbline 410
;                     bSmdStateR = enSmdInit;
	.dbline 411
;                     fSmdFuncR();              /* Motorbewegung ist beendet */
	mov.b #0,_bSmdStateR
	call _fSmdFuncR
	.dbline 412
;                     }
	.dbline 413
;                break;
L60:
L61:
	.dbline 415
;           }
;      return wTime;
	mov R4,R14
	.dbline -2
L59:
	pop R5
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 5 c
	.dbsym r wTime 4 i
	.dbend
	.area bss
	.dbfile C:\projekte\msp430\ct05\smd.c
	.even
_awRampR::
	.blkb 16
	.dbsym e awRampR _awRampR A[16:8]i
	.even
_awRampL::
	.blkb 16
	.dbsym e awRampL _awRampL A[16:8]i
_bSmdCountR::
	.blkb 1
	.dbsym e bSmdCountR _bSmdCountR c
_bSmdCountL::
	.blkb 1
	.dbsym e bSmdCountL _bSmdCountL c
_i8DirR::
	.blkb 1
	.dbsym e i8DirR _i8DirR C
_i8DirL::
	.blkb 1
	.dbsym e i8DirL _i8DirL C
	.even
_dwStepsR::
	.blkb 4
	.dbsym e dwStepsR _dwStepsR l
	.even
_dwStepsL::
	.blkb 4
	.dbsym e dwStepsL _dwStepsL l
_bRampR::
	.blkb 1
	.dbsym e bRampR _bRampR c
_bRampL::
	.blkb 1
	.dbsym e bRampL _bRampL c
	.even
_pBitMusterR::
	.blkb 2
	.dbsym e pBitMusterR _pBitMusterR pc
	.even
_pBitMusterL::
	.blkb 2
	.dbsym e pBitMusterL _pBitMusterL pc
	.even
_fSmdFuncR::
	.blkb 2
	.dbsym e fSmdFuncR _fSmdFuncR pfV
	.even
_fSmdFuncL::
	.blkb 2
	.dbsym e fSmdFuncL _fSmdFuncL pfV
_bSmdStateR::
	.blkb 1
	.dbsym e bSmdStateR _bSmdStateR c
_bSmdStateL::
	.blkb 1
	.dbsym e bSmdStateL _bSmdStateL c
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
