	.module tele.c
	.area lit
	.even
_stJobs::
	.byte 1
	.byte 0
	.word 15000
	.word 400,0
	.byte 4
	.byte 0
	.word 35000
	.word 125,0
	.byte 1
	.byte 0
	.word 15000
	.word 400,0
	.byte 4
	.byte 0
	.word 35000
	.word 125,0
	.byte 1
	.byte 0
	.word 15000
	.word 800,0
	.byte 3
	.byte 0
	.word 35000
	.word 125,0
	.byte 1
	.byte 0
	.word 15000
	.word 400,0
	.byte 3
	.byte 0
	.word 35000
	.word 125,0
	.byte 1
	.byte 0
	.word 15000
	.word 400,0
	.byte 3
	.byte 0
	.word 35000
	.word 125,0
	.byte 1
	.byte 0
	.word 15000
	.word 800,0
	.byte 4
	.byte 0
	.word 35000
	.word 125,0
	.byte 5
	.byte 0
	.word 20000
	.word 1852,0
	.byte 6
	.byte 0
	.word 20000
	.word 1852,0
	.byte 5
	.byte 0
	.word 20000
	.word 1852,0
	.byte 6
	.byte 0
	.word 20000
	.word 1852,0
	.dbfile C:\projekte\msp430\ct05\tele.c
	.dbsym e stJobs _stJobs A[128:16]X
	.area text
	.dbfile C:\projekte\msp430\ct05\tele.c
	.dbfunc e TELE_vInit _TELE_vInit fV
	.even
_TELE_vInit::
	.dbline -1
	.dbline 77
; /***************************************************************************
; * Titel        : TELE.C
; *
; * Description  : Telemtrie-Task
; *
; * Environment  : ICC430 V6.05, MSP430F149
; *
; * Responsible  : J. Altenburg
; *
; * Guidelines   :
; *
; * Revision List:
;   --------------------------------------------------------------------------
;   Date     | Author          | Change
;   --------------------------------------------------------------------------
;   12.02.04 |J. Altenburg     | first release
;   --------------------------------------------------------------------------
;            |                 |
;   --------------------------------------------------------------------------
; ****************************************************************************/
; 
; /***************************************************************************
; * HEADER-FILES (Only those that are needed in this file)                   *
; ****************************************************************************/
; /* System-headerfiles */
; #include "cdef.h"                  /* General definitions and types */
; #include "msp430x14x.h"         /* MSP430 definitions */
; #include "msp430def.h"
; 
; /* Own headerfiles */
; #include "tele.h"
; 
; /* Foreign headerfiles */
; #include "rf433.h"
; #include "navi.h"
; 
; /***************************************************************************
; * Defines und Makros
; ****************************************************************************/
; 
; /***************************************************************************
; *    Local Function Prototypes
; ****************************************************************************/
; typedef void (* fLocalFunc)( void );    /* function pointer */
; 
; 
; /***************************************************************************
; *    Global Variables
; ****************************************************************************/
; #define nSim    16 
; const NAVI_stJob stJobs[nSim] = {    enRobF, 15000, 400, /* 0 */
;                                      enRobR, 35000, 125, /* R */
;                                      enRobF, 15000, 400, /* 1 */
;                                      enRobR, 35000, 125, /* R */
;                                      enRobF, 15000, 800, /* 2 */
;                                      enRobL, 35000, 125, /* L */
;                                      enRobF, 15000, 400, /* 3 */
;                                      enRobL, 35000, 125, /* L */
;                                      enRobF, 15000, 400, /* 4 */
;                                      enRobL, 35000, 125, /* L */
;                                      enRobF, 15000, 800, /* 5 */
;                                      enRobR, 35000, 125, /* R */
;                                      enRobBl,20000, 1852,/* Bogen links */
;                                      enRobBr,20000, 1852,/* Bogen rechts */
;                                      enRobBl,20000, 1852,/* Bogen links */
;                                      enRobBr,20000, 1852,/* Bogen rechts */
;                                     }; /* Liste mit Testdaten */
; 
; /***************************************************************************
; *    Code Area
; ****************************************************************************/
; /***************************************************************************
; *    Function:  TELE-Init
; *
; *    Author:    Jens Altenburg
; ****************************************************************************/
; void TELE_vInit( void ){
	.dbline -2
	.dbline 78
;     }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e TELE_vMain _TELE_vMain fV
;              i -> R4
	.even
_TELE_vMain::
	push R4
	.dbline -1
	.dbline 84
; 
; /***************************************************************************
; *    Function:  TELE-Task
; *    Author:    Jens Altenburg
; ****************************************************************************/
; void TELE_vMain( void ){
	.dbline 85
;     byte i = 0;
	mov.b #0,R4
	jmp L4
L3:
	.dbline 86
;     while(1){
	.dbline 87
;         if(True == NAVI_bNewJob((NAVI_stJob*) &stJobs[i])){ /* Jobliste fllen */
	mov #_stJobs,R13
	mov R4,R12
	and #255,R12
	add R12,R12
	add R12,R12
	add R12,R12
	mov R12,R14
	add R13,R14
	call #_NAVI_bNewJob
	mov R14,r13
	cmp.b #1,r13
	jne L6
	.dbline 87
	.dbline 88
;             P5OUT ^= 0x01;
	xor.b #1,&0x31
	.dbline 89
;             i++;
	.dbline 90
;             if(i > nSim) i = 0;
	add.b #1,R4
	mov.b #16,R13
	cmp.b R4,R13
	jhs L8
	.dbline 90
	mov.b #0,R4
L8:
	.dbline 91
;             }
L6:
	.dbline 92
L4:
	.dbline 86
	jmp L3
X0:
	.dbline -2
	.dbline 93
;         }
;     }
L2:
	pop R4
	.dbline 0 ; func end
	ret
	.dbsym r i 4 c
	.dbend
	.area lit
	.even
	.area idata
	.even
	.area data
	.even
	.area bss
	.even
